# EasyCode

### EasyCode能做什么？

> EasyCode是基于IntelliJ IDEA Ultimate版开发的一个代码生成插件，主要通过自定义模板（基于velocity）来生成各种你想要的代码。通常用于生成Entity、Dao、Service、Controller。如果你动手能力强还可以用于生成HTML、JS、PHP等代码。理论上来说只要是与数据有关的代码都是可以生成的。
---
### 使用环境
`IntelliJ IDEA Ultimate版（172+）`

### 支持的数据库类型
##### 因为是基于Database Tool开发，所有Database Tool支持的数据库都是支持的。

包括如下数据库：
> 1. MySQL
> 2. SQL Server
> 3. Oracle
> 4. PostgreSQL
> 5. Sqlite
> 6. Sybase
> 7. Derby
> 8. DB2
> 9. HSQLDB
> 10. H2
>  
> 当然支持的数据库类型也会随着Database Tool插件的更新同步更新。

### 功能说明：
* 支持多表同时操作
* 支持同时生成多个模板
* 支持自定义模板
* 支持自定义类型映射（支持正则）
* 支持自定义附加列
* 支持列附加属性
* 所有配置项目支持分组模式，在不同项目（或选择不同数据库时），只需要切换对应的分组，所有配置统一变化。

##### 功能对比：

功能|Easy Code|其他工具
---|---|---
自定义模板|支持|支持
多表生成|支持|支持
生成方式|无缝集成在项目中|部分工具需要复制粘贴
附加列|支持|不支持
附加列属性|支持|不支持
动态调试模板|支持|不支持
图形化界面|支持|部分支持
使用环境|仅限IDEA|支持各种形式
在线支持|后期扩展|不支持
自定义类型映射|支持|部分支持
全局变量|支持|不支持


### 使用文档：
[点击查看WIKI文档](https://gitee.com/makejava/EasyCode/wikis/pages)

### 一、在线安装
> ##### 动图教程：
> ![在线安装](../../raw/master/%E6%95%99%E7%A8%8B%E5%9B%BE%E7%89%87/1-1/%E5%9C%A8%E7%BA%BF%E5%AE%89%E8%A3%85.gif "在线安装")
> ##### 说明文档：
> ``` 说明文档：
> 1. 安装完毕后重启生效。
> 2. 版本更新时不会覆盖现有模板。
> ```

### 二、手动安装
> [ **点击这里** ](../../releases)，下载最新的发行版本。
> ##### 动图教程
![手动安装](../../raw/master/%E6%95%99%E7%A8%8B%E5%9B%BE%E7%89%87/1-1/%E6%9C%AC%E5%9C%B0%E5%AE%89%E8%A3%85.gif "手动安装")
> ##### 说明文档：
> ``` 说明文档：
> 1. 安装完毕后重启生效。
> 2. 版本更新时不会覆盖现有模板。
> 3. 不要解压zip包，安装时直接选zip包即可。
> ```  

#### QQ群1：[373603580](https://shang.qq.com/wpa/qunwpa?idkey=4d495321e527ec2ce459c0d0d6320414cd9677d92d5287df831d4e1c4ec09740)
#### QQ群2：[167490920](https://qm.qq.com/cgi-bin/qm/qr?k=r0emWZbPZIb6BqxpLM4Z4jo2mHoC0zZK&jump_from=webapi)
#### Telegram：[https://t.me/gotoeasycode](https://t.me/gotoeasycode)
